#ifndef CLC_ERRNO_H
#define CLC_ERRNO_H

#ifdef __cplusplus
extern "C" {
#endif

#include <limits.h>

/* Copyright (c) 2003, B. Augestad (boa@metasystems.no) */

/* Min and max legal libclc error numbers. Do not change. */
#define CLC_EMIN (INT_MAX/2)
#define CLC_EMAX (CLC_EMIN + 1000)

/* Error numbers */
#define CLC_ENOSPC (CLC_EMIN + 0)	/* Not enough space */
#define CLC_ENOMEM (CLC_EMIN + 1)	/* Allocation of memory failed */

extern const char* clc_strerror(int clc_errnum);
extern void clc_perror(const char* clc_s);
extern int clc_iserror(int clc_errnum);

#ifdef __cplusplus
}
#endif

#endif /* CLC_ERRNO_H */

