/* $Id: clc_string.h,v 1.16 2003/06/08 11:30:45 augestad Exp $ */

#ifndef CLC_STRING_H
#define CLC_STRING_H

#include <stddef.h>
#include "clc_settings.h"

#ifdef __cplusplus
extern "C" {
#endif

char* clc_strdup(const char* CLC_RESTRICT clc_s);

char* clc_strtrim(char* clc_s);
char* clc_strrtrim(char* clc_s);
char* clc_strltrim(char* clc_s);
char* clc_strnormws(char *clc_s);

char* clc_strlower(char *clc_s);
char* clc_strupper(char *clc_s);

void* clc_memrev(void *clc_s, size_t clc_n);
char* clc_strrev(char *clc_s);

char**clc_strsplit(const char *clc_s, const char *clc_delim);
void  clc_strarray_free(char **clc_strings);

int clc_strcasecmp(const char *clc_s1, const char *clc_s2);
int clc_strncasecmp(const char *clc_s1, const char *clc_s2, size_t clc_len);

char* clc_stralloc(const char *clc_arg1, ...);

char* clc_stpcpy(
	char* CLC_RESTRICT clc_s1,
	const char* CLC_RESTRICT clc_s2);

char* clc_strendcpy(
	char* clc_dest,
	const char* CLC_RESTRICT clc_src,
	const char* clc_end);

size_t clc_ultostr(
	char* clc_dest,
	size_t clc_size,
	unsigned long clc_num,
	int clc_base);

size_t clc_strlcpy(
	char* CLC_RESTRICT clc_dest,
	const char* CLC_RESTRICT clc_src,
	size_t clc_size);

size_t clc_strlcat(
	char* CLC_RESTRICT clc_dest,
	const char* CLC_RESTRICT clc_src,
	size_t clc_size);

char* clc_strsep(
	char** CLC_RESTRICT clc_stringp,
	const char* CLC_RESTRICT clc_delim);

char* clc_strtok_r(
	char* clc_str,
	const char* CLC_RESTRICT clc_delim,
	char** clc_tracker);

char *clc_strreplace(
	const char *clc_src,
	const char *clc_old,
	const char *clc_new);

char *clc_strsub(
	char *CLC_RESTRICT clc_dest,
	char *CLC_RESTRICT clc_src,
	size_t clc_offset,
	size_t clc_len);

char *clc_strleft(
	char *CLC_RESTRICT clc_dest,
	char *CLC_RESTRICT clc_src,
	size_t clc_len);

char *clc_strright(
	char *CLC_RESTRICT clc_dest,
	char *CLC_RESTRICT clc_src,
	size_t clc_len);

char* clc_strcasestr(const char *haystack, const char *needle);

#ifdef __cplusplus
}
#endif

#endif /* CLC_STRING_H */
